﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using System.Web.Mvc;

using NUnit.Framework;

using EcoMvcExample.MvcWebsite;
using EcoMvcExample.MvcWebsite.Controllers;

using Rhino.Mocks;


namespace EcoMvcExample.MvcWebsite.Tests.Controllers
{
    /// <summary>
    /// Summary description for HomeControllerTest
    /// </summary>
    [TestFixture]
    public class HomeControllerTest
    {
        [Test]
        public void Index()
        {
            // Setup
            // New Attempt
            MockRepository mocks = new MockRepository();
            MockHttpContext mockRequest = new MockHttpContext(mocks);
            MvcMockHelpers.FakeHttpContext(mocks);
            
            
            mocks.ReplayAll();

            HomeController controller = new HomeController();
            controller.EcoSpaceType = typeof(TestMemoryEcoSpace);

            // Execute
            ViewResult result = controller.Index() as ViewResult;

            // Verify
            IDictionary<string, object> viewData = result.ViewData as IDictionary<string, object>;
            Assert.AreEqual("Home Page", viewData["Title"]);
            Assert.AreEqual("Welcome to ASP.NET MVC!", viewData["Message"]);

            mocks.VerifyAll();
        }

        [Test]
        public void About()
        {
            // Setup
            HomeController controller = new HomeController();

            // Execute
            ViewResult result = controller.About() as ViewResult;

            // Verify
            IDictionary<string, object> viewData = result.ViewData as IDictionary<string, object>;
            Assert.AreEqual("About Page", viewData["Title"]);
        }
    }
}
